#include <iostream>
#include <cstdlib>
#include "Player.h"
using namespace std;
using namespace guessinggame;

//Declares non-class functions to run game
void play (Player &player1, Player &player2);
bool checkForWin(int guess, int answer, bool &guess_too_high);

//Main driver
int main (int argc, char * const argv[])
{
	HumanPlayer player1;
	ComputerPlayer player2;
	play(player1, player2);

}
//Function to check if a player has guessed correctly
bool checkForWin(int guess, int answer, bool &guess_too_high)
{
	cout << "You guessed " << guess << ".";
	if (answer == guess)
	{
		cout << "You're right!  You win!" << endl;
		return true;
	}
	if (answer < guess)
	{
		cout << "Your guess is too high." << endl;
		guess_too_high = true;
		return false;
	}
	if (answer > guess)
	{
		cout << "Your guess is too low." << endl;
		guess_too_high = false;
		return false;
	}

}

//Play function that runs the game till its end, and gives users useful information to play
void play (Player &player1, Player &player2)
{
	int answer = 0, guess = 0;
	srand(time(NULL));
	answer = rand() % 100;
	bool win = false;
	bool guess_too_high = false;

	while (!win)
	{
		cout << "Player 1's turn to guess." << endl;
		guess = player1.getGuess();
		win = checkForWin(guess, answer, guess_too_high);
		if (win) return;
		player1.storeLastGuess(guess, guess_too_high);
		player2.storeLastGuess(guess, guess_too_high);

		cout << "Player 2's turn to guess." << endl;
		guess = player2.getGuess();
		win = checkForWin(guess, answer,guess_too_high);
		player1.storeLastGuess(guess, guess_too_high);
		player2.storeLastGuess(guess, guess_too_high);
	}
}
