#include "Player.h"
#include <iostream>
#include <cstdlib>

using namespace std;

namespace guessinggame
{
	const int NUMBER_CEILING = 99;
	const int NUMBER_FLOOR = 0;
	//Player constructor
	Player::Player()
	{

	}
	//virtual getGuess function not to be used with parent player
	int Player::getGuess()
	{
		return 0;
	}

	//virtual storeLastGuess function not to be used with parent player
	void Player::storeLastGuess(int,bool)
	{

	}

	//Prompts user to enter his/her guess and assigns to the driving program
	int HumanPlayer::getGuess()
	{
		int guess;
		do
		{
			cout << "Enter a guess (0-99):" << endl;
			cin >> guess;

		} while (guess < 0 || guess > 99);
		return guess;
	}

	//Constructor for Computer Player
	ComputerPlayer::ComputerPlayer() : Player() , max_number(NUMBER_CEILING), min_number(NUMBER_FLOOR)
	{

	}

	//Stores most recent guess as max or min (unless guess out of current max/min range)
	void ComputerPlayer::storeLastGuess(int last_guess, bool too_high)
	{
		if (too_high && (last_guess < max_number))
		{
			max_number = last_guess-1;
		}
		if ((!too_high) && (last_guess > min_number))
		{
			min_number = last_guess+1;
		}

	}

	//Algorithm to generate a logical guess to maximize wins against an opponent
	int ComputerPlayer::getGuess()
	{
		int guess;
		int randFactor = max_number - min_number + 1;
		srand(time(NULL));
		guess = min_number + (rand() % randFactor);

		//send him a 9
		//send him a
		randFactor = rand() % 2;
		switch (max_number - min_number + 1) {
			case 21:
				if (randFactor == 1)
				{
					guess = min_number+9;
				}
				else
				{
					guess = max_number-9;
				}
			case 20:
				if (randFactor == 1)
				{
					guess = min_number+10;
				}
				else
				{
					guess = max_number-10;
				}
			case 19:
				if (randFactor == 1)
				{
					guess = min_number+7;
				}
				else
				{
					guess = max_number-7;
				}
			case 18:
				if (randFactor == 1)
				{
					guess = min_number+9;
				}
				else
				{
					guess = max_number-9;
				}
			case 17:
				if (randFactor == 1)
				{
					guess = min_number+7;
				}
				else
				{
					guess = max_number-7;
				}
			case 16:
				if (randFactor == 1)
				{
					guess = min_number+10;
				}
				else
				{
					guess = max_number-10;
				}
			case 15:
				if (randFactor == 1)
				{
					guess = min_number+7;
				}
				else
				{
					guess = max_number-7;
				}
			case 14:
				if (randFactor == 1)
				{
					guess = min_number+7;
				}
				else
				{
					guess = max_number-7;
				}
			case 13:
				if (randFactor == 1)
				{
					guess = min_number+7;
				}
				else
				{
					guess = max_number-7;
				}
				break;
			case 12:
				if (randFactor == 1)
				{
					guess = min_number+7;
				}
				else
				{
					guess = max_number-7;
				}
				break;
			case 11:
				if (randFactor == 1)
				{
					guess = min_number+7;
				}
				else
				{
					guess = max_number-7;
				}
				break;
			case 10:
				if (randFactor == 1)
				{
					guess = min_number+9;
				}
				else
				{
					guess = max_number-9;
				}
				break;
			case 9:
				if (randFactor == 1)
				{
					guess = min_number+1;
				}
				else
				{
					guess = max_number-1;
				}
				break;
			case 8:
				if (randFactor == 1)
				{
					guess = min_number+3;
				}
				else
				{
					guess = max_number-3;
				}
				break;
			case 7:
				if (randFactor == 1)
				{
					guess = min_number+3;
				}
				else
				{
					guess = max_number-3;
				}
				break;
			case 6:
				if (randFactor == 1)
				{
					guess = min_number+1;
				}
				else
				{
					guess = max_number-1;
				}
				break;
			case 5:
				if (randFactor == 1)
				{
					guess = min_number+2;
				}
				else
				{
					guess = max_number-2;
				}
				break;
			case 4:
				if (randFactor == 1)
				{
					guess = min_number;
				}
				else
				{
					guess = max_number;
				}
				break;
			case 3:
				if (randFactor == 1)
				{
					guess = min_number;
				}
				else
				{
					guess = max_number;
				}
				break;
			case 2:
				if (randFactor == 1)
				{
					guess = min_number;
				}
				else
				{
					guess = max_number;
				}
				break;
			case 1:
				if (randFactor == 1)
				{
					guess = min_number;
				}
				else
				{
					guess = max_number;
				}

			default:
				break;
		}

		cout << "The computer guesses " << guess << endl;
		return guess;
	}

}
