#ifndef PLAYER_H
#define PLAYER_H

//Declares class Player, and its descendants HumanPlayer and ComputerPlayer in namespace guessinggame

namespace guessinggame
{
	//Player with empty constructor and two virtual functions to store guesses and generate a guess
	class Player
	{
	public:
		Player();
		virtual int getGuess();
		virtual void storeLastGuess(int,bool);
	};

	//Human player with getGuess function
	class HumanPlayer : public Player
	{
	public:
		virtual int getGuess();
	};

	//Computer Player with constructor and two variables to store current max and min
	class ComputerPlayer : public Player
	{
	public:
		ComputerPlayer();
		virtual void storeLastGuess(int last_guess, bool too_high);
		virtual int getGuess();
	private:
		int max_number;
		int min_number;
	};
}


#endif
